package org.richfaces;

import org.ajax4jsf.test.base.RichSeleniumTest;
import org.ajax4jsf.test.base.SeleniumTestBase;
import org.ajax4jsf.test.base.Templates;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;


public class AjaxCommandButtonTest extends SeleniumTestBase implements RichSeleniumTest {

    public AjaxCommandButtonTest() {
        super("http", "localhost", "8080");
    }
    
    /**
     * This method are invoking before selenium tests started
     */
    @BeforeTest
    @Parameters( { "browser" })
    public void startSelenium(String browser) {
    	super.startSelenium(browser);
    }
    
    /**
     * This method are invoking after selenium tests completed
     */
    @AfterTest
    public void stopSelenium() {
    	super.stopSelenium();
    }

    @Test
    public void testAjaxCommandButtonComponent() throws Exception {
    	_testAjaxCommandButtonComponent(Templates.SIMPLE);
    	_testAjaxCommandButtonComponent(Templates.DATATABLE);
    	_testAjaxCommandButtonComponent(Templates.MODALPANEL);
    }

    private void _testAjaxCommandButtonComponent(Templates template) {
        renderPage(getTestUrl(), template);
    
    	String parentId = getParentId() + "_form:";
    	
        String buttonId = parentId + "b1";
        String inputId = parentId + "_value";

        writeStatus("Click button 1 : ");
        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "12345");

        writeStatus("Click button 1 again: ");
        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "123452345");

        buttonId = parentId + "b2";

        writeStatus("Click button 2: ");
        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "1234523455");

        buttonId = parentId + "b3";

        writeStatus("Click button 3: ");
        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "1234523455");

        buttonId = parentId + "b4";

        writeStatus("Click button 4: ");
        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "12345234555");

        buttonId = parentId + "b5";

        writeStatus("Click button 5: ");
        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "12345234555");
    
    }

	public String getTestUrl() {
		return "/faces/pages/ajaxCommandButton/ajaxButtonTest.xhtml";
	}

}
